import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Guy here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Guy extends Actor
{
     private double acceleration = 0.05;
     private double vSpeed = 0;
    /**
     * Act - do whatever the Guy wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        checkFall();
    }
    
    public void checkFall()
    {
        if(onHouse()) {
            vSpeed = 0;
            ((MyWorld)getWorld()).incCaughtScore();
            getWorld().removeObject(this);
            GreenfootSound sound=new GreenfootSound("CLICK7C.WAV");
            sound.play();
        }
        else{
            if (outOfWorld()) {
                ((MyWorld)getWorld()).incFallenScore();
                getWorld().removeObject(this);
                GreenfootSound sound=new GreenfootSound("Fall.wav");
                sound.play();
            }
            else{
                fall();
            }
        }
    }
    
    public void fall()
    {
        setLocation ( getX(), (int)(getY() + vSpeed));
        vSpeed = vSpeed + acceleration;
    }
    
    public boolean onHouse()
    {
        Actor under = getOneObjectAtOffset ( 0, getImage().getHeight() / 2, House.class);
        return under != null;
    }
    
    private boolean outOfWorld()
    {
        return  (getY() >= getWorld().getHeight()-15);
    }
}
